﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using SLTTData3.ServiceReference1;
using System.Windows.Browser;

namespace SLTTData3
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
        }
        List<Order> oO;
        List<Order> oM;

        int pageSize = 20;

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            GetData();
        }
        void GetData()
        {
            loadingAni.Begin();
            loadingTextBlock.Text = " Loading data.....";
            loadingTextBlock.Visibility = Visibility.Visible;

            ServiceReference1.Service1Client client = new SLTTData3.ServiceReference1.Service1Client();
            client.GetOrdersByShipCityCompleted += new EventHandler<SLTTData3.ServiceReference1.GetOrdersByShipCityCompletedEventArgs>(client_GetOrdersByShipCityCompleted);
            client.GetOrdersByShipCityAsync(cityBox.Text,(int)myScrollbar.Value,pageSize);
        }

        void client_GetOrdersByShipCityCompleted(object sender, SLTTData3.ServiceReference1.GetOrdersByShipCityCompletedEventArgs e)
        {
            oO = e.Result.ToList();
            oM = LinqToSqlClientHelper.LinqHelper.GetShallowCopy<Order>(oO);
            dataGrid.ItemsSource = oM;

            int rowtotal = e.count;
            myScrollbar.Maximum = rowtotal;
            if (rowtotal > pageSize)
                myScrollbar.Visibility = Visibility.Visible;
            else
                myScrollbar.Visibility = Visibility.Collapsed;

            loadingAni.Stop();
            loadingTextBlock.Visibility = Visibility.Collapsed;


        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            LinqToSqlClientHelper.LinqHelper.GetModifiedsObjectsOnly<Order>(oM, oO, "OrderID");
            ServiceReference1.Service1Client client = new SLTTData3.ServiceReference1.Service1Client();
            client.SaveOrdersCompleted += new EventHandler<SaveOrdersCompletedEventArgs>(client_SaveOrdersCompleted);
            client.SaveOrdersAsync(oO.ToArray(), oM.ToArray());
        }

        void client_SaveOrdersCompleted(object sender, SaveOrdersCompletedEventArgs e)
        {
            HtmlPage.Window.Alert(e.Result);
        }

        private void myScrollbar_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            GetData();
            
        }

        private void myScrollbar_Scroll(object sender, ScrollEventArgs e)
        {
            loadingTextBlock.Visibility = Visibility.Visible;
            loadingTextBlock.Text = "Row number: " + ((int)myScrollbar.Value).ToString();

        }

        private void UserControl_KeyUp(object sender, KeyEventArgs e)
        {
            if(e.Key == Key.Ctrl)
                Application.Current.Host.Content.IsFullScreen = !Application.Current.Host.Content.IsFullScreen; 
        }
    }
}
